'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  return {
    visitor: {
      Program: function (path) {
        var name = path.scope.generateUid('Promise');

        var used = false;
        path.traverse(replaceIdentifier, {
          getReplacement: function () {
            used = true;
            return t.identifier(name);
          }
        });

        if (used) {
          path.unshiftContainer('body', buildPolyfill({
            PROMISE: t.identifier(name)
          }));
        }
      }
    }
  };
};

var _babelTemplate = require('babel-template');

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buildPolyfill = (0, _babelTemplate2.default)('\n  var PROMISE = typeof Promise === \'undefined\'\n    ? require(\'es6-promise\').Promise\n    : Promise\n');

var replaceIdentifier = {
  ReferencedIdentifier: function (path) {
    var node = path.node,
        parent = path.parent,
        scope = path.scope;


    if (t.isMemberExpression(parent)) return;
    if (node.name !== 'Promise') return;
    if (scope.getBindingIdentifier(node.name)) return;

    path.replaceWith(this.getReplacement());
  }
};
//# sourceMappingURL=index.js.map